(require 'asdf)
(push #P"../systems/" asdf:*central-registry*)
(asdf:oos 'asdf:load-op 'abop)
(in-package :abop)

(defparameter *argument* nil)
(with-open-file (stream "argument.txt")
  (setf *argument* (read-line stream)))

(format t "argument is ~A~%" *argument*)

(defun find-last-slash (str)
  (let ((last nil))
    (dotimes (i (length str) last)
      (when (eq #\/ (char str i))
        (setf last i)))))

(defun is-absolute (path-str)
  (and (stringp path-str) (eq #\/ (char path-str 0))))

(defparameter *cut* (find-last-slash *argument*))

(defun relative-path (path-part)
  (concatenate 'string 
	       (namestring *default-pathname-defaults*) "/../" path-part))

(defun new-default-path ()
  (let ((path-part (subseq *argument* 0 (1+ *cut*))))
    (pathname
     (if (is-absolute *argument*)
	 path-part
	 (relative-path path-part)))))

(if *cut*
    (progn
      (setf *default-pathname-defaults* (new-default-path))
      (format t "executing in ~A~%" *default-pathname-defaults*)
      (load (subseq *argument* (1+ *cut*))))
    (all))

(sb-ext:quit)

(all)

